;File Name        : NoMouse02.as
;Version          : 0.2
;Last Up Date     : 2006/04/25
;Program Language : HSP Ver. 2.6 (http://www.onionsoft.net/hsp/)
;Author           : Tomohiko Sato
;URL1 : http://www.vector.co.jp/vpack/browse/person/an038336.html (Japanese)
;URL2 : http://www.hi5.com/friend/displayProfile.do?userid=35985557 (English)
;Comment : Mouse contorol with Tenkey , Can 1 or 2 Crick (3 Bottun)
;          Can Drop, CAN NOT Drag.

;#include "hspext.as" ;for 
#include "llmod.as" ; for mouse_event
#include "input.as" ; for mouse_event

#define PROGNAME "No_Mouse" 		; Program name
#define PROGVER  "0.2"			; Program version
#define PROGAUTHOR  "Tomohiko Sato"	; Program author
#define PROG_RUN curdir + "\\" 		; This Program Running path
#define TITL PROGNAME + " " 		; Window Title
#define SCR0X 270 			; Window screen ID=0 X size
#define SCR0Y 260 			; Window screen ID=0 Y size
	
	
;============================
; Set Window
;============================
	WinID=0
	screen WinID, SCR0X, SCR0Y, 0
	cls 1 ; gray
	title TITL+"Ver."+PROGVER

;============================
;Set default value
;============================

	mes "+---+-+---+ Tenkey '/' : Left"
	mes "| / |*| - | Tenkey '*' : Middle"
	mes "+---+-+---+ Tenkey '-' : Right"
	mes "|    8    | Tenkey '2' : "
	mes "| 4  5+ 6 | Tenkey '4' : "
	mes "|    2    | Tenkey '6' : "
	mes "+---------+ Tenkey '8' : "
	mes "            Tenkey '5' : 1 Click"
	mes "            Tenkey '+' : 2 Click"
	mes "            [Delete]   : Drop"
	mes "  Fig. Mouse and Tenkey "
	mes "  Author : Tomohiko Sato"

	;[Wait Time]
	MainWait=20 	; Main Loop Wait Time (x1ms)    <- Load Info file!
	ClkWait=20 	; Mouse Click Wait Time (x10ms) <- Load Info file!

	;[Key Code for mouse_event, getkey]
	MC_Drag =45	;Drag(Keep selected mouse click   )  [Insert]=45
	MC_Drop =46	;Drop(Destroy selected mouse click)  [Delete]=46

	Cursor_Down  = 98 	;  Tnekey'2'=  98
	Cursor_Left  =100 	;  Tnekey'4'= 100
	Cursor_Right =102 	;  Tnekey'6'= 102
	Cursor_Up    =104 	;  Tnekey'8'= 104

	MC_One    = 101 	; Tenkey'5'=101
	MC_Double = 107		; Tenkey'+'=107

	MC_Left   = 111  	; Tenkey '/' = 111
	MC_Middle = 106  	; Tenkey '*' = 106
	MC_Right  = 109  	; Tenkey '-' = 109

	; [Default Mouse Selected Flg]
	LeftSel_flg=0 		; Left Selected Flg
	MiddleSel_flg=0 	; Middle Selected Flg
	RightSel_flg=0 		; Right Selected Flg

	; [Default Mouse Click Flg]
	Left1Cl_flg=0 		; Left 1 Click Flg
	Left2Cl_flg=0 		; Left 2 Click Flg
	Middle1Cl_flg=0 	; Middle 1 Click Flg
	Middle2Cl_flg=0 	; Middle 2 Click Flg
	Right1Cl_flg=0 		; Right 1 Click Flg
	Right2Cl_flg=0 		; Right 2 Click Flg

	;[Default Mouse Drag, Drop Flg]
	Drag_flg=0 : Drop_flg=0

;============================
;Set Object
;============================
objsize 50, 25
pos (SCR0X-50)/2, SCR0Y-30 : button "Exit", *Prog_End ; Obj ID=0


;/*======================
;Main Loop
;========================
*main

repeat
	await MainWait 	; Delay Main Time (Default : 10ms)
	title TITL+"Ver."+PROGVER

	;[ Move Mouse with Tnekey]
	movx=0 : movy=0
	getkey a,  98 : if a : movy+	; Tnekey'2'=  98
	getkey a, 100 : if a : movx-	; Tnekey'4'= 100
	getkey a, 102 : if a : movx+	; Tnekey'6'= 102
	getkey a, 104 : if a : movy-	; Tnekey'8'= 104

	mouse_event $1, movx, movy

	;[ Left / Middle / Right Select Flg ]
	getkey kMC_Left, MC_Left 	: if kMC_Left==1 	: LeftSel_flg=1
	getkey kMC_Middle, MC_Middle 	: if kMC_Middle==1 	: MiddleSel_flg=1
	getkey kMC_Right, MC_Right 	: if kMC_Right==1 	: RightSel_flg=1

	;[Drag]
	getkey kMC_Drag, MC_Drag : if kMC_Drag==1 : Drag_flg=1

	;[Drop]
	getkey kMC_Drop, MC_Drop : if kMC_Drop==1 : Drop_flg=1
	if Drop_flg==1 : gosub *Sub_Drop

	;[ 1 Click Check Flg ]
	getkey kMC_One, MC_One
	if kMC_One==1 : Left1Cl_flg=1 : Middle1Cl_flg=1 : Right1Cl_flg=1

	;[ 2 Click Check Flg ]
	getkey kMC_Double, MC_Double
	if kMC_Double==1 : Left2Cl_flg=1 : Middle2Cl_flg=1 : Right2Cl_flg=1

	;[Go Subrouthin for 1 or 2 Click ]
	if (LeftSel_flg==1)&(Left1Cl_flg==1) : gosub *Left1Click
	if (LeftSel_flg==1)&(Left2Cl_flg==1) : gosub *Left2Click
	if (MiddleSel_flg==1)&(Middle1Cl_flg==1) : gosub *Middle1Click
	if (MiddleSel_flg==1)&(Middle2Cl_flg==1) : gosub *Middle2Click
	if (RightSel_flg==1)&(Right1Cl_flg==1) : gosub *Right1Click
	if (RightSel_flg==1)&(Right2Cl_flg==1) : gosub *Right2Click


	;if (Drop_flg==1) : 
loop
	
	; [Default Mouse Selected Flg]
	LeftSel_flg=0 		; Left Selected Flg
	MiddleSel_flg=0 	; Middle Selected Flg
	RightSel_flg=0 		; Right Selected Flg

	; [Default Mouse Click Flg : gosub *Def_Flg]
	Left1Cl_flg=0 		; Left 1 Click Flg
	Left2Cl_flg=0 		; Left 2 Click Flg
	Middle1Cl_flg=0 	; Middle 1 Click Flg
	Middle2Cl_flg=0 	; Middle 2 Click Flg
	Right1Cl_flg=0 		; Right 1 Click Flg
	Right2Cl_flg=0 		; Right 2 Click Flg


	goto *main

;=======================*/
stop


;/*======================
; Excute
;========================




stop


*Prog_End
	dialog "Exit this program ?", 3, "Alart : Exit?"
	if stat = 6 : end 			; stat : Yes=6, No=7
	if stat = 7 : goto *main
End

;========================
;Subrouthin
;========================

;/*--- [Default Flg Value] ---
*Def_Flg
	LeftSel_flg=0 : Left1Cl_flg=0 : Left2Cl_flg=0
	MiddleSel_flg=0 : Middle1Cl_flg=0 : Middle2Cl_flg=0
	RightSel_flg=0 : Right1Cl_flg=0 : Right2Cl_flg=0
	Drop_flg=0 : Drag_flg=0
return
;--- [Default Flg Value] ---*/


;/*--- [Mouse Left 1 Click] ---
*Left1Click
	;1 click
	if (LeftSel_flg==1)&(Left1Cl_flg==1){
	repeat 1
			a=$2 					; Left Mouse Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title "Left 1 Click"
			;mes "Left 1 Click"
			wait ClkWait : mouse_event $4 		; Left Mouse Pull Up
			a=0 
	loop
	}
	gosub *Def_Flg
	return
;---  [Mouse Left 1 Click] ---*/

;/*--- [Mouse Left 2 Click] ---
*Left2Click
	if (LeftSel_flg==1)&(Left2Cl_flg==1){
		repeat 2
			a=$2 					; Left Mouse Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title "Left 2 Click"
			;mes "Left 2 Click" + cnt
			wait ClkWait : mouse_event $4		; Left Mouse Pull Up 
			a=0
		loop
		}
	gosub *Def_Flg
	return
;---  [Mouse Left 2 Click] ---*/

;/*--- [Mouse Middle 1 Click] ---
*Middle1Click
	if (MiddleSel_flg==1)&(Middle1Cl_flg==1){
	repeat 1
			a=$20 				; Middle Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title "Middle 1 Click"
			;mes "Middle 1 Click " + cnt
			wait ClkWait : mouse_event $40 	; Middle Pull Up 
			a=0
	loop
	}
	gosub *Def_Flg
	return
;---  [Mouse Middle 1 Click] ---*/

;/*--- [Mouse Middle 2 Click] ---
*Middle2Click
	if (MiddleSel_flg==1)&(Middle2Cl_flg==1){
	repeat 2
			a=$20 				; Middle Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title "Middle 2 Click"
			;mes "Middle 2 Click " + cnt
			wait ClkWait : mouse_event $40 	; Middle Pull Up 
			a=0
	loop
	}
	gosub *Def_Flg
	return
;---  [Mouse Middle 2 Click] ---*/

;/*--- [Mouse Right 1 Click] ---
*Right1Click
	if (RightSel_flg==1)&(Right1Cl_flg==1){
	repeat 1
			a=$8 				; Right Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title "Right 1 Click"
			;mes "Right 1 Click"
			wait ClkWait : mouse_event $10 	; Right Pull Up
			a=0
	loop
	}
	gosub *Def_Flg
	return
;---  [Mouse Right 1 Click] ---*/

;/*--- [Mouse Right 2 Click] ---
*Right2Click
	if (RightSel_flg==1)&(Right2Cl_flg==1){
	repeat 2
			a=$8 				; Right Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title "Right 2 Click"
			;mes "Right 2 Click"
			wait ClkWait : mouse_event $10 	; Right Pull Up
			a=0
	loop
	}
	gosub *Def_Flg
	return
;---  [Mouse Right 2 Click] ---*/


*Sub_Drop
	if LeftSel_flg==1 : mouse_event $4 : title "Mouse Left Pull Up"	; Left Mouse Pull Up 
	if MiddleSel_flg==1 : mouse_event $40 : title "Mouse Middle Pull Up" ; Middle Pull Up 
	if RightSel_flg==1 : mouse_event $10 : title "Mouse Right Pull Up" ; Right Pull Up
	wait ClkWait
	title "Drop (All Mouse key Pull Up)"
	wait ClkWait
	gosub *Def_Flg
return
