;File Name        : NoMouse03.as
;Version          : 0.3
;Last Up Date     : 2006/04/28
;Program Language : HSP Ver. 2.6 (http://www.onionsoft.net/hsp/)
;Author           : Tomohiko Sato
;URL1 : http://www.vector.co.jp/vpack/browse/person/an038336.html (Japanese)
;URL2 : http://www.hi5.com/friend/displayProfile.do?userid=35985557 (English)
;Comment : Mouse contorol with Tenkey , Can 1 or 2 Crick (3 Bottun)
;          Can Drag & Drop.
;	   Tasktray IN/OUT, Menubar.

;#include "hspext.as" ;for 
#include "llmod.as" ; for mouse_event
#include "input.as" ; for mouse_event
#include "Srexhsp.as" ; for Task IN/OUT, Menubar, exapend (Srexhsp Ver 2.51)

#define PROGNAME "No_Mouse" 		; Program name
#define PROGVER  "0.3"			; Program version
#define PROGAUTHOR  "Tomohiko Sato"	; Program author
#define PROG_RUN curdir + "\\" 		; This Program Running path
#define TITL PROGNAME + " " 		; Window Title
#define SCR0X 300 			; Window screen ID=0 X size
#define SCR0Y 20 			; Window screen ID=0 Y size
#define WINID0POSX (dispx - SCR0X)/2 	; Window screen ID=0 X Position
#define WINID0POSY (dispy - SCR0Y)/2 	; Window screen ID=0 Y Position
#define BUF_MAX 32000 			; Buffer Max
#define PATH_MAX 1024 			; Buffer 1 Line Max
#define TASK_IN_MENU 3			; Task IN menu number

;Define for About Help (WinID=2)
#define SCR2X 300 			; Window screen ID=2 X size
#define SCR2Y 340 			; Window screen ID=2 Y size
#define WINID2POSX (dispx - SCR2X)/2 	; Window screen ID=2 X Position
#define WINID2POSY (dispy - SCR2Y)/2 	; Window screen ID=2 Y Position
;============================
; Set Window
;============================
	WinID=0
	screen WinID, SCR0X, SCR0Y, 0, WINID0POSX, WINID0POSY
	cls 1 ; gray
	TITL_mes1 = TITL+"Ver."+PROGVER
	title TITL_mes1
	exapend TITL_mes1 : if stat==1 : end 		;Inhibition of Duplication program 
	gsel WinID, 1

;============================
;Set Menu
;============================
	toolset $800,1
	toolsys 0 ;IDB_STD_SMALL_COLOR      0 (15)

;======================================
;create Menu bar (Sub->Main)
;======================================
;File      Help     
;[Edit]    [About]	
;[Load]
;[Tasktray In]                          
;[Exit]
;-----------
; Sub Menu
;-----------
;Popup Menu(Menu1)
;Menu1(File&F) > Sub
	menuset 1
	menuadd "Edit(&E)", 1000 		;Event ID=1000
	menuadd "Load(&L)",1100   		;Event ID=1100
	menuadd "", ,$800               	;Separater
	menuadd "Tasktray In(&I)", 1200 	;Event ID=1200
	;menuadd "Tasktray Out(&O)", 1300 	;Event ID=1300
	menuadd "", ,$800               	;Separater
	menuadd "Exit(&X)",1400         	;Event ID=1400

;Menu2(Help&H) > Sub
	menuset 2
	menuadd "About(&A)", 2000 		;Event ID=2000

;Task tray in menu
	menuset TASK_IN_MENU
	menuadd "Edit(&E)", 1000 		;Event ID=1000
	menuadd "Load(&L)",1100   		;Event ID=1100
	menuadd "", ,$800               	;Separater
	menuadd "Tasktray Out(&O)", 1300   	;Event ID=1300
	menuadd "", ,$800     		        ;Separater
	menuadd "About Help(&A)", 2000 		;Event ID=2000
	menuadd "No Mouse Exit(&X)",1400        ;Event ID=1400

;==============
;Main menu
;==============
	menuset 
	menuadd "File(&F)", 1, $10
	menuadd "Help(&H)", 2, $10

	menudsp ;Display Menu

;============================
;Set default value
;============================
	;[Status Message]
	mes_SelL= "Selected Left"
	mes_SelM= "Selected Middle"
	mes_SelR= "Selected Right"
	mes_L1C= "Left 1 Click"
	mes_M1C= "Middle 1 Click"
	mes_R1C= "Right 1 Click"
	mes_L2C= "Left 2 Click"
	mes_M2C= "Middle 2 Click"
	mes_R2C= "Right 2 Click"
	mes_LPR = "Left Pull Up"
	mes_MPU = "Middle Pull Up"
	mes_RPU = "Right Pull Up"
	mes_Drp= "Drop(All Key Pull Up)"


*Check_NMsetIni
	sdim Buf, BUF_MAX 		; Buf : Buffer
	sdim LineBuf, PATH_MAX 		; LineBuf : Line Buffer
	sdim EditorPath, PATH_MAX 	; EditorPath: Editor(Notepad.exe) Path

	;[Wait Time <- Load from NMsetIniPath]
	NMsetIniPath= PROG_RUN + "NMset.ini"
	exist NMsetIniPath : if strsize==-1 : gosub *MakeIniFile
	gosub *Reload_NMsetIniPath

	;/*--- Key Code ---
	;[Key Code for mouse_event, getkey]
	MC_Drag =45	;Drag(Keep selected mouse click   )  [Insert]=45
	MC_Drop =46	;Drop(Destroy selected mouse click)  [Delete]=46

	Cursor_Down  = 98 	;  Tnekey'2'=  98
	Cursor_Left  =100 	;  Tnekey'4'= 100
	Cursor_Right =102 	;  Tnekey'6'= 102
	Cursor_Up    =104 	;  Tnekey'8'= 104

	MC_One    = 101 	; Tenkey'5'=101
	MC_Double = 107		; Tenkey'+'=107

	MC_Left   = 111  	; Tenkey '/' = 111
	MC_Middle = 106  	; Tenkey '*' = 106
	MC_Right  = 109  	; Tenkey '-' = 109
	;--- Key Code ---*/

	;/*--- Flg ---
	; [Default Mouse Selected Flg]
	LeftSel_flg=0 		; Left Selected Flg
	MiddleSel_flg=0 	; Middle Selected Flg
	RightSel_flg=0 		; Right Selected Flg

	; [Default Mouse 1, 2 Click Flg]
	MC_One_flg=0 		; Mouse 1 click Flg
	MC_Double_flg=0 	; Mouse 2 click Flg

	;[Default Mouse Drag, Drop Flg]
	Drag_flg=0 : Drop_flg=0

	;[Tasktray In Flg]
	TaskIn_flg=0
	;--- Flg ---*/
;============================
;Set Object
;============================
	objsize 50, 25

	;pos 5, SCR0Y-30 : button "Edit", *Edit_NMsetIni 	; Obj ID=0
	;pos 50*1+10, SCR0Y-30 : button "Load", *Check_NMsetIni ; Obj ID=1
	;pos 50*2+15, SCR0Y-30 : button "Exit", *Prog_End 	; Obj ID=2

	exhinfo 28 : hwnd=stat ; Get Window Hundle

;/*======================
;Main Loop
;========================
*main
; Mouse Move
; Select Left, Middle, Right
; 1Click =>
; 2Click =>
; Drag =>
; Drop=>
repeat
	await MainWait 	; Delay Main Time (Default : 10ms)
	toolcmd : q=stat : if q!0 : gosub *s_cmd
	title TITL+"Ver."+PROGVER
	onexit *Prog_End

	;[ Move Mouse with Tnekey]
	gosub *Move_Mouse

	;[ Left / Middle / Right Select Flg ]
	getkey kMC_Left, MC_Left     : if kMC_Left==1   : LeftSel_flg=1 : MiddleSel_flg=0 : RightSel_flg=0
	getkey kMC_Middle, MC_Middle : if kMC_Middle==1 : LeftSel_flg=0 : MiddleSel_flg=1 : RightSel_flg=0
	getkey kMC_Right, MC_Right   : if kMC_Right==1  : LeftSel_flg=0 : MiddleSel_flg=0 : RightSel_flg=1 

	;[Title Change > Selected Mouse Key]
	if (LeftSel_flg==1) : title mes_SelL 		;Selected Left
	if (MiddleSel_flg==1) : title mes_SelM 		;Selected Middle
	if (RightSel_flg==1) : title mes_SelR 		;Selected Right

	;[Drag]
	getkey kMC_Drag, MC_Drag : if kMC_Drag==1 : Drag_flg=1 : Drop_flg=0

	;[Drop => *Sub_Drop]
	getkey kMC_Drop, MC_Drop : if kMC_Drop==1 : Drag_flg=0 : Drop_flg=1 
	if Drop_flg==1 : gosub *Sub_Drop

	;[ 1 Click Check Flg ]
	getkey kMC_One, MC_One
	if kMC_One==1 : MC_One_flg=1 : MC_Double_flg=0

	;[ 2 Click Check Flg ]
	getkey kMC_Double, MC_Double
	if kMC_Double==1 : MC_One_flg=0 : MC_Double_flg=1 

	;[Go Subrouthin for 1 or 2 Click ]
	if (LeftSel_flg==1)&(MC_One_flg==1) 	: gosub *Left1Click
	if (LeftSel_flg==1)&(MC_Double_flg==1)  : gosub *Left2Click
	if (MiddleSel_flg==1)&(MC_One_flg==1) 	: gosub *Middle1Click
	if (MiddleSel_flg==1)&(MC_Double_flg==1): gosub *Middle2Click
	if (RightSel_flg==1)&(MC_One_flg==1) 	: gosub *Right1Click
	if (RightSel_flg==1)&(MC_Double_flg==1) : gosub *Right2Click


	;[Go Subrouthin for Drag]
	if (LeftSel_flg==1)&(Drag_flg=1) 	: gosub *LeftDrag
	if (MiddleSel_flg==1)&(Drag_flg=1) 	: gosub *MiddleDrag
	if (RightSel_flg==1)&(Drag_flg=1) 	: gosub *RightDrag

	;[Task IN]
	if TaskIn_flg==1 : goto *trayin
loop

;goto *main
;=======================*/
stop


;/*======================
; Excute
;========================

;/*---Main1 File >Tasktray In
*trayin
	;Tasktray IN
	if TaskIn_flg==1 : taskclr
	tasktry TITL
	gsel WinID, -1

*tray_loop
	;Tasktray IN Loop
	await MainWait 		; Delay Main Time (Default : 10ms)
	ginfo 1 	;prmx=ActiveWinID, prmy=gselWinID
	taskcmd
	if (stat==1) : goto *trayout 	; 1 : Left 1 click
	if (stat==2) : goto *r_pop 	; 2 : Right 1 click
	;/*-------- Main Loop --------
	;[ Move Mouse with Tnekey]
	gosub *Move_Mouse

	;[ Left / Middle / Right Select Flg ]
	getkey kMC_Left, MC_Left     : if kMC_Left==1 	: LeftSel_flg=1 : MiddleSel_flg=0 : RightSel_flg=0
	getkey kMC_Middle, MC_Middle : if kMC_Middle==1 : LeftSel_flg=0 : MiddleSel_flg=1 : RightSel_flg=0
	getkey kMC_Right, MC_Right   : if kMC_Right==1 	: LeftSel_flg=0 : MiddleSel_flg=0 : RightSel_flg=1

	;[Drag]
	getkey kMC_Drag, MC_Drag : if kMC_Drag==1 : Drag_flg=1 : Drop_flg=0

	;[Title Change > Selected Mouse Key]
	if (LeftSel_flg==1) : title mes_SelL 	; Selected Left
	if (MiddleSel_flg==1) : title mes_SelM 	; Selected Middle
	if (RightSel_flg==1) : title mes_SelR 	; Selected Right

	;[Drop]
	getkey kMC_Drop, MC_Drop : if kMC_Drop==1 : Drag_flg=0 : Drop_flg=1
	if Drop_flg==1 : gosub *Sub_Drop

	;[ 1 Click Check Flg ]
	getkey kMC_One, MC_One
	if kMC_One==1 : MC_One_flg=1 : MC_Double_flg=0

	;[ 2 Click Check Flg ]
	getkey kMC_Double, MC_Double
	if kMC_Double==1 : MC_One_flg=0 : MC_Double_flg=1

	;[Go Subrouthin for 1 or 2 Click ]
	if (LeftSel_flg==1)&(MC_One_flg==1) 	 : gosub *Left1Click
	if (LeftSel_flg==1)&(MC_Double_flg==1) 	 : gosub *Left2Click
	if (MiddleSel_flg==1)&(MC_One_flg==1) 	 : gosub *Middle1Click
	if (MiddleSel_flg==1)&(MC_Double_flg==1) : gosub *Middle2Click
	if (RightSel_flg==1)&(MC_One_flg==1) 	 : gosub *Right1Click
	if (RightSel_flg==1)&(MC_Double_flg==1)  : gosub *Right2Click
	;-------- Main Loop -------*/
	toolcmd : q=stat : if q!0 : goto *s_cmd2
	goto *tray_loop

*trayout
	;Tasktray OUT
	TaskIn_flg=0
	gsel WinID, 1 : extask 8 		; Window Active
	taskclr
	goto *main

*r_pop
	;Mouse Right Click(512) in Task IN
	menusel TASK_IN_MENU 				; TASK_IN_MENU
	k=512 : menupop k, hwnd, 0
	goto *tray_loop

*s_cmd2
	if (q == 1000) : goto *Edit_NMsetIni
	if (q == 1100) : goto *Reload_NMsetIniPath 
	if (q == 1200) : TaskIn_flg=1 : goto *trayin
	if (q == 1300) : TaskIn_flg=0 : goto *trayout  ;Event ID=1300
	if (q == 2000) : goto *About_Help
	if (q == 1400) : goto *Prog_End 		;Event ID=1400
	goto *tray_loop
;--- ---*/

*Edit_NMsetIni
	exist NMsetIniPath
	if strsize==-1 : gosub *MakeIniFile
	if strsize>=BUF_MAX : delete NMsetIniPath : gosub *MakeIniFile

	; Notepad for Win98
	EditorPath = windir + "\\notepad.exe"
	exist EditorPath
	if strsize==-1 : dialog "No Exit File.\n"+EditorPath, 1, "Alart"
	exec  EditorPath + " " + NMsetIniPath 		
	title "Edit Setting File"
	wait 20
goto *main

*About_Help
	screen 2, SCR2X, SCR2Y, 4, WINID2POSX, WINID2POSY
	cls 1 : gsel 2, 1 		; Window ID=2 Active
	title "About Help "+ PROGNAME + " Ver."+ PROGVER
	mes "+---+-+---+ Tenkey '/' : Left"
	mes "| / |*| - | Tenkey '*' : Middle"
	mes "+---+-+---+ Tenkey '-' : Right"
	mes "|    8    | Tenkey '2' : Move to "
	mes "| 4  5+ 6 | Tenkey '4' : Move to "
	mes "|    2    | Tenkey '6' : Move to "
	mes "+---------+ Tenkey '8' : Move to "
	mes "            Tenkey '5' : 1 Click"
	mes "            Tenkey '+' : 2 Click"
	mes "            [Insert]   : Drag"
	mes "            [Delete]   : Drop"
	mes ""
	mes "  Fig. Mouse and Tenkey "
	mes ""
	mes "  Program Name : "+PROGNAME
	mes "  Version : "+PROGVER
	mes "  Author : "+PROGAUTHOR
	objsize 50, 25
	pos (SCR2X-50)/2, SCR2Y-30 : button "Close", *CloseWinID2 ;obj ID=0
	objsel 0
	if TaskIn_flg==1 : taskclr : goto *trayin
	if TaskIn_flg==0 : goto *trayout
stop

*CloseWinID2
	gsel 2, -1
	if TaskIn_flg==1 : taskclr : goto *trayin
	if TaskIn_flg==0 : goto *trayout
stop


*Prog_End
	dialog "Exit this program ?", 3, "Alart : Exit?"
	if stat = 7 : goto *main
	if stat = 6 : taskclr		; stat : Yes=6, No=7
End

;========================
;Subrouthin
;========================

;/*----- Create Setting Information File as NMsetIniPath -----
;MainWait=15 	; Main Loop Wait Time (x1ms)    <- Load Info file!
;ClkWait=30 	; Mouse Click Wait Time (x10ms) <- Load Info file!
;DragWait=15 	; Mose Drag Wait Time (x10ms)   <- Load Info file!
*MakeIniFile
	Buf  =""
	Buf +="[No Mouse Setting Information]\n"  				;0
	Buf +="[2L: Main Loop Wait Time(x1ms)]\n" 				;1
	Buf +="15\n" 		; MainWait = Main Loop Wait Time (x1ms) 	;2
	Buf +="[4L: Click Wait Time(x10ms)]\n" 					;3
	Buf +="30\n" 		; ClkWait  = Mouse Click Wait Time (x10ms) 	;4
	Buf +="[6L: Drag Wait Time(x10ms)]\n" 					;5
	Buf +="15\n" 		; DragWait = Mose Drag Wait Time (x10ms) 	;6
	strlen BufLen, Buf
	if BufLen >= (BUF_MAX - PATH_MAX) : BufLen = UF_MAX - PATH_MAX
	bsave NMsetIniPath, Buf, BufLen
	buf=""
	;Debug
	;dialog "Created File.\n"+NMsetIniPath+"\nSize:"+BufLen+"Byte", 0, "*MakeIniFile Debug"
return
; ----- Create Setting Information File as NMsetIniPath -----*/

;/*--- Tasktray ---
*s_cmd 
	;Menu1(File&F)
	if (q == 1000) : goto *Edit_NMsetIni
	if (q == 1100) : goto *Reload_NMsetIniPath 
	if (q == 1200) : TaskIn_flg=1 : goto *trayin
	if (q == 1300) : TaskIn_flg=0 : goto *trayout 
	if (q == 1400) : goto *Prog_End

	;Menu2(Help&H)
	if (q == 2000) : goto *About_Help
return
;--- Tasktray ---*/

;/*----- [Reload_NMsetIniPath] -----
*Reload_NMsetIniPath
	exist NMsetIniPath
	if strsize==-1 : gosub *MakeIniFile
	if strsize>=BUF_MAX : delete NMsetIniPath : gosub *MakeIniFile
	bload NMsetIniPath, Buf, strsize
	notesel Buf
	LIdx_Max=0
	notemax LIdx_Max
	;repeat LIdx_Max
	;	noteget LineBuf, Idx
	;	Idx+=1
	;loop

	if LIdx_Max >= 7{				; Idx=0..LIdx_Max
		Idx=2 : noteget MainWait, Idx
		Idx=4 : noteget ClkWait, Idx
		Idx=6 :	noteget DragWait, Idx
	}else{
		Idx=0 : noteadd "[No_Mouse Setting Information]", Idx, 1 
		Idx=1 : noteadd "[2L: Main Loop Wait Time(x1ms)]", Idx, 1
		Idx=2 : 	MainWait="15"  : noteadd MainWait, Idx, 1
		Idx=3 : noteadd "[4L: Click Wait Time(x10ms)]", Idx, 1 
		Idx=4 : 	ClkWait = "30" : noteadd ClkWait, Idx, 1
		Idx=5 : noteadd "[6L: Drag Wait Time(x10ms)]", Idx, 1
		Idx=6 :		DragWait="15"  : noteadd DragWait, Idx, 1
	}
	sdim LoadMes1, PATH_MAX
	LoadMes1  = "Main Loop :"+MainWait+"(x1ms)\n"
	LoadMes1 += "Clik :"+ClkWait+"(x10ms)\n"
	LoadMes1 += "DragWait :"+DragWait+"(x10ms)"
	dialog LoadMes1, 0, PROGNAME + " Ver."+ PROGVER +" Wait Time Setting"
	int MainWait : int ClkWait : int DragWait
return
; ---- [Reload_NMsetIniPath] ----*/

;/*--- [Default Flg Value] ---
*Def_Flg
	LeftSel_flg=0 : MiddleSel_flg=0 : RightSel_flg=0
	MC_One_flg=0 : MC_Double_flg=0
	Drop_flg=0 : Drag_flg=0 : a=0
return
;--- [Default Flg Value] ---*/

;/*--- [Move Mouse] ---
*Move_Mouse
	movx=0 : movy=0
	getkey a, Cursor_Down : if a : movy+	; Tnekey'2'=  98
	getkey a, Cursor_Left : if a : movx-	; Tnekey'4'= 100
	getkey a, Cursor_Right : if a : movx+	; Tnekey'6'= 102
	getkey a, Cursor_Up : if a : movy-	; Tnekey'8'= 104
	if a==1 : a=0
	mouse_event $1+a, movx, movy
return
;--- [Move Mouse] ---*/

;/*--- [Mouse Left 1 Click] ---
*Left1Click
	if (LeftSel_flg==1)&(MC_One_flg==1){
	repeat 1
		a=$2 					; Left Mouse Push Down
		wait ClkWait : mouse_event $1+a, movx, movy
		;Left 1 Click			
		title mes_L1C 		;+ " "+ movx + " "+movy+ " "+ a
		;title "(mousex, mousey)=(" + mousex +", "+ mousey+"), "+stat	
		if TaskIn_flg==1 : gsel WinID, -1
		if TaskIn_flg==0 : gsel WinID, 1
		wait ClkWait : mouse_event $4	; Left Mouse Pull Up
		a=0
	loop
	gosub *Def_Flg
	}else{
		a=0
		gosub *Def_Flg 
	}
	return
;---  [Mouse Left 1 Click] ---*/

;/*--- [Mouse Left 2 Click] ---
*Left2Click
	if (LeftSel_flg==1)&(MC_Double_flg==1){
		repeat 2
			a=$2 					; Left Mouse Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			title mes_L2C 				; Left 2 Click

			if TaskIn_flg==1 : gsel WinID, -1
			if TaskIn_flg==0 : gsel WinID, 1
			wait ClkWait : mouse_event $4		; Left Mouse Pull Up 
			a=0
		loop
		gosub *Def_Flg
	}else{
		gosub *Def_Flg
	}
	return
;---  [Mouse Left 2 Click] ---*/

;/*--- [Mouse Middle 1 Click] ---
*Middle1Click
	if (MiddleSel_flg==1)&(MC_One_flg==1){
		repeat 1
			a=$20 				; Middle Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			;Middle 1 Click
			title mes_M1C
			;mes "Middle 1 Click " + cnt
			if TaskIn_flg==1 : gsel WinID, -1
			if TaskIn_flg==0 : gsel WinID, 1
			wait ClkWait : mouse_event $40 	; Middle Pull Up 
			a=0
		loop
		gosub *Def_Flg
	}else{
		gosub *Def_Flg
	}
	return
;---  [Mouse Middle 1 Click] ---*/

;/*--- [Mouse Middle 2 Click] ---
*Middle2Click
	if (MiddleSel_flg==1)&(MC_Double_flg==1){
		repeat 2
			a=$20 				; Middle Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			;Middle 2 Click
			title mes_M2C 
			if TaskIn_flg==1 : gsel WinID, -1
			if TaskIn_flg==0 : gsel WinID, 1
			wait ClkWait : mouse_event $40 	; Middle Pull Up 
			a=0
		loop
		gosub *Def_Flg
	}else{
		gosub *Def_Flg
	}
	return
;---  [Mouse Middle 2 Click] ---*/

;/*--- [Mouse Right 1 Click] ---
*Right1Click
	if (RightSel_flg==1)&(MC_One_flg==1){
		repeat 1
			a=$8 				; Right Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			;Right 1 Click
			title mes_R1C
			;mes "Right 1 Click"
			if TaskIn_flg==1 : gsel WinID, -1
			if TaskIn_flg==0 : gsel WinID, 1
			wait ClkWait : mouse_event $10 	; Right Pull Up
			a=0
		loop
		gosub *Def_Flg
	}else{
		gosub *Def_Flg
	}
	return
;---  [Mouse Right 1 Click] ---*/

;/*--- [Mouse Right 2 Click] ---
*Right2Click
	if (RightSel_flg==1)&(MC_Double_flg==1){
		repeat 2
			a=$8 				; Right Push Down
			wait ClkWait : mouse_event $1+a, movx, movy
			;Right 2 Click
			title mes_R2C 
			;mes "Right 2 Click"
			if TaskIn_flg==1 : gsel WinID, -1
			if TaskIn_flg==0 : gsel WinID, 1
			wait ClkWait : mouse_event $10 	; Right Pull Up
			a=0
		loop
		gosub *Def_Flg
	}else{
		gosub *Def_Flg
	}
	return
;---  [Mouse Right 2 Click] ---*/

;************************************************************************
; [ Drag ]
;************************************************************************
;/*--- LeftDrag ---
*LeftDrag
	repeat
		;gosub *Move_Mouse
		movx=0 : movy=0
		getkey a, Cursor_Down 	: if a : movy+	; Tnekey'2'=  98
		getkey a, Cursor_Left 	: if a : movx-	; Tnekey'4'= 100
		getkey a, Cursor_Right 	: if a : movx+	; Tnekey'6'= 102
		getkey a, Cursor_Up 	: if a : movy-	; Tnekey'8'= 104
		wait DragWait 				; DragWait=15(Default) Drag delay time(x10ms)
		title mes_SelL +" Drag"	;Selected Left
		;title "a="+a+", movx="+movx+", movy"+movy + ", cnt"+cnt			
		mouse_event $1, movx, movy
		wait DragWait 				; DragWait=15(Default) Drag delay time(x10ms)
		a=$2 					; $2 : Mouse Left Push Down
		mouse_event $1 + a, movx, movy
		;pset mousex, mousey
		getkey kMC_Drop, MC_Drop
		if kMC_Drop==1 : gosub *Sub_Drop 		;Drop
		if Drag_flg==0 : break
	loop
	;Debu
	;dialog "Drop",0,"Left Debug"
return
;--- LeftDrag ---*/

;/*--- MiddleDrag ---
*MiddleDrag
	repeat
		;gosub *Move_Mouse
		movx=0 : movy=0
		getkey a, Cursor_Down 	: if a : movy+	; Tnekey'2'=  98
		getkey a, Cursor_Left 	: if a : movx-	; Tnekey'4'= 100
		getkey a, Cursor_Right 	: if a : movx+	; Tnekey'6'= 102
		getkey a, Cursor_Up 	: if a : movy-	; Tnekey'8'= 104
		wait DragWait 				; DragWait=15(Default) Drag delay time(x10ms)
		title mes_SelM +" Drag"			; Selected Middle Drag
		;title "a="+a+", movx="+movx+", movy"+movy + ", cnt"+cnt			
		mouse_event $1, movx, movy
		wait DragWait 				; DragWait=15(Default) Drag delay time(x10ms)
		a=$20 					; $20 : Mouse Middle Push Down
		mouse_event $1 + a, movx, movy
		;pset mousex, mousey
		getkey kMC_Drop, MC_Drop
		if kMC_Drop==1 : gosub *Sub_Drop 		;Drop
		if Drag_flg==0 : break
	loop
	;Debu
	;dialog "Drop",0,"Middle Debug"
return
;--- MiddleDrag ---*/

;/*--- RightDrag ---
*RightDrag
	repeat
		;gosub *Move_Mouse
		movx=0 : movy=0
		getkey a, Cursor_Down 	: if a : movy+	; Tnekey'2'=  98
		getkey a, Cursor_Left 	: if a : movx-	; Tnekey'4'= 100
		getkey a, Cursor_Right 	: if a : movx+	; Tnekey'6'= 102
		getkey a, Cursor_Up 	: if a : movy-	; Tnekey'8'= 104
		wait DragWait 				; DragWait=15(Default) Drag delay time(x10ms)
		title mes_SelR +" Drag"			; Selected Right Drag
		;title "a="+a+", movx="+movx+", movy"+movy + ", cnt"+cnt			
		mouse_event $1, movx, movy
		wait DragWait 				; DragWait=15(Default) Drag delay time(x10ms)
		a=$8 					; $8 : Mouse Right Push Down
		mouse_event $1 + a, movx, movy
		;pset mousex, mousey
		getkey kMC_Drop, MC_Drop
		if kMC_Drop==1 : gosub *Sub_Drop 		;Drop
		if Drag_flg==0 : break
	loop
	;Debu
	;dialog "Drop",0,"Right Debug"
return
;--- RightDrag ---*/



;****************************************************************************
; [Drop]
;****************************************************************************
*Sub_Drop
	; [Left Pull Up]
	if LeftSel_flg==1 { 
		MC_One_flg=0
		MC_Double_flg=0
		Drag_flg=0
		mouse_event $4  ; $4
		title mes_LPR 	; Left Pull Up
	} 
	; [Middle Pull Up] 
	if MiddleSel_flg==1 {
		MC_One_flg=0
		MC_Double_flg=0
		Drag_flg=0
		mouse_event $40 ; $40
		title mes_MPU 	; Middle Pull Up 
	}
	; [Right Pull Up]
	if RightSel_flg==1 {
		MC_One_flg=0
		MC_Double_flg=0
		Drag_flg=0 
		mouse_event $10 ; $10
		title mes_RPU 	; Right Pull Up
	}
	wait ClkWait 	; Mouse Click Wait time
	title mes_Drp 	; Drop (All Mouse key Pull Up)
	wait ClkWait 	; Mouse Click Wait time
	gosub *Def_Flg
return
